:- use_module(library(chr)).
:- set_prolog_flag(prompt_alternatives_no_bindings, true). % SWI-prolog specific

:- chr_constraint father/2, mother/2.

father(X,Y), father(Z,Y) ==> Z=X.
mother(X,Y), mother(Z,Y) ==> Z=X.

% Enable these rules to remove duplicates
% The answer set will look somewhat odd, though ...
/* 
father(X,Y) \ father(X,Y) <=> true.
mother(X,Y) \ mother(X,Y) <=> true.
*/

grandfather(X,Z):- father(X,Y), father(Y,Z).
grandfather(X,Z):- father(X,Y), mother(Y,Z).

current_db:-
    father(peter, paul),
    father(paul,jens),
    mother(marie,jens).


% ?- current_db, grandfather(X,jens).